﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Diagnostics;

namespace AppDomainPerformanceDemo
{
    class Program
    {
        const int COUNT = 500000;

        static void Main( string[] args )
        {
            FunA();
            FunB();
            FunC();
            FunD();

            Console.ReadLine();
        }

        
        static void FunC()
        {
            RemoterProxy remoterProxy = new RemoterProxy();
            CodeTimer.Time( "RemoterProxy:  Same AppDomain", COUNT, remoterProxy.FunTest );
        }

        static void FunD()
        {
            AppDomain domain = AppDomain.CreateDomain( "NewAppDomain" );
            RemoterProxy remoterProxy = (RemoterProxy)domain.CreateInstanceAndUnwrap( Assembly.GetExecutingAssembly().FullName, "AppDomainPerformanceDemo.RemoterProxy" ); ;
            CodeTimer.Time( "RemoterProxy:  Across AppDomain", COUNT, remoterProxy.FunTest );
            AppDomain.Unload( domain );
        }

        static void FunB()
        {
            IInterface inter = new ImplementA();
            CodeTimer.Time( "ImplementA:  Same AppDomain", COUNT, inter.FunA );
        }

        static void FunA()
        {
            AppDomain domain = AppDomain.CreateDomain( "NewAppDomain" );
            RemoterProxy remoterProxy = (RemoterProxy)domain.CreateInstanceAndUnwrap( Assembly.GetExecutingAssembly().FullName, "AppDomainPerformanceDemo.RemoterProxy" );;
            IInterface inter = remoterProxy.CreateInstance( "AppDomainPerformanceDemo.ImplementA", "MyImplement", BindingFlags.CreateInstance, null );
            CodeTimer.Time( "ImplementA:  Across AppDomain", COUNT, inter.FunA );
            AppDomain.Unload( domain );
        
        }
    }

    public class RemoterProxy : MarshalByRefObject
    {
        public IInterface CreateInstance( string typeName, string assemblyName, BindingFlags bindingFlags, object[] constructorParams )
        {
            Assembly owningAssembly = Assembly.Load( assemblyName );

            IInterface instanceHandler = owningAssembly.CreateInstance( typeName) as IInterface;//, false, bindingFlags, null, constructorParams, null, null ) as IInterface;

            return instanceHandler;
        }

        public void FunTest()
        {
        }
    }

    
}
